// Example - enforce.cpp



// ignore testing Enforce for now...

#if 0
#include <io.h> // only on Windows platforms,

/* for Unix, instead of #include <io.h>

#include <unistd.h>
#define _read read
*/

struct Test
{
    Test( int i) : m_i( i)
    {}
    void print_i()
    { std::cout << "test=" << m_i << std::endl; }
private:
    int m_i;
};


struct HandlePredicate
{
    static bool Wrong(long handle)
    {
        return handle == -1;
    }
};
#define HANDLE_ENFORCE(exp) \
    boost::smart_assert::MakeEnforcer<HandlePredicate, boost::smart_assert::DefaultRaiser>((exp), "Expression '" #exp "' failed in '" \
    __FILE__ "', line: ", __LINE__).SMART_ENFORCE_A



void test_enforce()
{
    int i = 0;
    int *p = &i;

    int * p2 = ENFORCE( p)(p);
    *p2 = 1;

    try {
        int * p3 = ENFORCE( (int*)0);
    } catch( ...)
    {}

    Test t( 6);
    Test * pTest = &t;
    ENFORCE(pTest)(pTest)->print_i();

    // will of course faile
    int file = -1;
    void *buffer = NULL;
    int buflen = 40;
    try {
        const int available = 
            HANDLE_ENFORCE(_read(file, buffer, buflen))(file)(buffer)(buflen);
    }
    catch (...)
    {}

}

#endif
